Description
Possible interpretations
    -  UTF-8 string (as in Protocol Buffers)
    -  ASCII string
    -  Array of bytes
Should be handled with two string wire-schemas: 
    -  utf-8-string: decoding attempts on invalid data should signal an error
    -  ascii-string: decoding attempts on invalid data should signal an error

Language-specific details are documented in [[Types]]. In particular, limitations of the current C++ implementation are discussed
there.

Related issues:
Related to Robotics Service Bus - Bug # 367: Wire Schema Error on Deserializi... Resolved 06/11/2011

Associated revisions
Revision 815fcb2c - 06/11/2011 08:40 PM - J. Wienke

    -  use bytearray for SpreadPort instead of str
    -  adapt handling of strings refs #338

Revision 6a9912a8 - 06/12/2011 06:10 PM - J. Moringen
Improved define-basic-converter-test-cases in test/converter/package.lisp
refs #338
    -  test/converter/package.lisp (define-basic-converter-test-cases):

  generate additional test cases domain->wire-smoke and
  wire->domain-smoke; allow wire-data and domain-object to be :error
  to indicate a failing conversion for one direction

Revision 89978fd3 - 06/12/2011 06:10 PM - J. Moringen
Split string into utf-8 and acsii in src/converter/fundamental.lisp
refs #338
    -  src/converter/fundamental.lisp

  (wire->domain? eql :fundamental-ascii-string simple-array eql
  :ascii-string): new method; part of new ASCII converter
  (domain->wire? eql :fundamental-ascii-string string): likewise
  (wire->domain eql :fundamental-ascii-string simple-array eql
  :ascii-string): likewise
  (domain->wire eql :fundamental-ascii-string string): likewise
  (wire->domain? eql :fundamental-utf-8-string simple-array eql
  :utf-8-string): changed specializers :fundamental-string >
  :fundamental-utf-8-string and :string -> :utf-8-string
  (domain>wire? eql :fundamental-utf-8-string string): similar
  (wire->domain eql :fundamental-utf-8-string simple-array eql
  :utf-8-string): similar
  (domain->wire eql :fundamental-utf-8-string string): similar

    -  test/converter/fundamental.lisp (file local variables): added utf-8
  coding
  (define-basic-converter-test-cases :fundamental-null): added more
  cases
  (test suite fundamental-ascii-string-root): new test suite; for
  fundamental-ascii-string converter
  (define-basic-converter-test-cases :fundamental-ascii-string): new
  basic test case definition
  (test suite fundamental-utf-8-string-root): renamed
  fundamental-string-root > fundamental-utf-8-string-root
  (define-basic-converter-test-cases :fundamental-utf-8-string): added
  test cases that actually exercise UTF-8 en and decoding

Revision b50689b2 - 06/12/2011 06:10 PM - J. Moringen
Fixed default converter for strings in src/configuration.lisp
refs #338
    -  src/configuration.lisp (options-from-default-sources): use

  :fundamental-utf-8-string instead of :fundamental-string as default
  converter

Revision 9cb8e77b - 06/12/2011 08:24 PM - J. Wienke

make properties aware of utf8 and ascii and leave string for backwards compatibility refs #338

Revision 4f891c56 - 06/12/2011 09:16 PM - J. Moringen
Changes for changed converter name in lisp/config.lisp
refs #338
    -  lisp/config.lisp: changed option name ... :string ->

  ... :utf-8-string

History
#1 - 06/09/2011 03:48 PM - J. Moringen
- Description updated

#2 - 06/10/2011 01:07 PM - J. Wienke

Forced ASCII-Conversion for Java.

#3 - 06/10/2011 01:12 PM - J. Wienke
- % Done changed from 0 to 20

#4 - 06/10/2011 03:01 PM - J. Moringen
- Description updated
we will skip the intermediate solution

#5 - 06/12/2011 06:10 PM - J. Moringen
- % Done changed from 20 to 70

#6 - 06/12/2011 09:32 PM - J. Moringen
- Description updated
- Status changed from New to Resolved

#7 - 06/23/2011 10:26 PM - J. Moringen
- % Done changed from 70 to 100
